﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub
Public Sub perfectNumbers(dummy As Int) As List

	Dim mylist As List
	mylist = nativeMe.RunMethod("perfectNumbers",Array(dummy))
	Return mylist
End Sub
Sub LogNew_P(Value As String, dur As Long)

	Dim args(2) As String
	args(0) = Value
	args(1) = dur
	CallSubDelayed2("Main", "update_label4",args)

End Sub

#If Java

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import anywheresoftware.b4a.keywords.Common;
import java.util.concurrent.TimeUnit;

  private long begin = 0;
  private long end   = 0;
  String EventName = "LogNew";
  
  
  
	public List perfectNumbers(int dummy) {
		begin = System.currentTimeMillis();
		List<BigDecimal> numbers = get(dummy);

//		BA.Log("perfectNumber = " + numbers);
		end = System.currentTimeMillis();
		BA.Log("" + (end-begin) / 1000 + " seconds");
		return numbers;
	}

	public List<BigDecimal> get(int size) {
		List<BigDecimal> numbers = new ArrayList<BigDecimal>();
		BigInteger p = BigInteger.ZERO.nextProbablePrime();
		while (numbers.size() < (size - 1)) {
			if (isMersennePrime(p.longValue())) {
//				BA.Log("Found factor for 'p' = " + p);
				numbers.add(calculate(p.intValue()));
				long end = System.currentTimeMillis();
//		        BA.Log("" + (end-begin) / 1000 + " seconds");
				ba.raiseEventFromUI(this, EventName.toLowerCase(BA.cul) + "_p", p.toString(), (end-begin) / 1000);
				
			}
			p = p.nextProbablePrime();
		}

		return numbers;
	}

	BigDecimal calculate(int p) {
		BigDecimal d = new BigDecimal(2);
		BigDecimal f1 = (d.pow(p - 1));
		BigDecimal f2 = (d.pow(p).subtract(new BigDecimal(1)));
		return (f1.multiply(f2));
	}

	boolean isMersennePrime(long p) {
		return lucasLehmer((int) p);
	}

	public static boolean lucasLehmer(int p) {
		BigInteger s = BigInteger.valueOf(4);
		BigInteger m = BigInteger.valueOf(2).pow(p).subtract(BigInteger.ONE);
		for (int i = 0; i < p - 2; i++)
			s = s.multiply(s).subtract(BigInteger.valueOf(2L)).mod(m);

		return s.equals(BigInteger.ZERO);
	}
	


#End If
